// src/node/useNodeWorker.ts
import worker_threads from "worker_threads";

// src/is/isArray.ts
var isArray = Array.isArray;

// src/node/useNodeWorker.ts
function useProcressNodeWorker(callback) {
  const { parentPort } = worker_threads;
  parentPort.on(
    "message",
    async (data) => parentPort == null ? void 0 : parentPort.postMessage(await (callback == null ? void 0 : callback(data)) || (() => ""))
  );
}

// src/node/jsShell.ts
import child_process from "child_process";
function jsShell(commander, options = "inherit") {
  let args = [];
  let stdio = "inherit";
  let errorExit = true;
  let isLog = false;
  let cwd;
  if (typeof options === "string") {
    stdio = options;
  } else {
    args = options.args || [];
    stdio = options.stdio || "inherit";
    errorExit = options.errorExit || true;
    isLog = options.isLog || false;
    cwd = options.cwd;
  }
  return isArray(commander) ? commander.map((command) => executor(command)) : executor(commander);
  function executor(commander2) {
    var _a;
    const { status, output } = child_process.spawnSync(
      commander2,
      args,
      {
        shell: true,
        encoding: "utf8",
        stdio: stdio === "inherit" ? "inherit" : ["inherit", "pipe", "inherit"],
        cwd
      }
    );
    const result = (_a = output[1]) == null ? void 0 : _a.trim();
    if (status === 130) {
      if (isLog)
        console.log("\u5DF2\u53D6\u6D88...");
      return { status, result };
    }
    if (status !== 0) {
      if (isLog)
        console.log(result);
      if (errorExit)
        process.exit(1);
    }
    return { status, result };
  }
}

// src/worker/useNodeWorkerThread.ts
useProcressNodeWorker(
  ({ params, stdio = "pipe", errorExit, isLog }) => jsShell(`${params}`, { stdio, errorExit, isLog })
);
